#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#ifdef BSD
#include <sys/elf32.h>
#include <sys/elf64.h>
#endif
#ifdef LINUX
#include <elf.h>
#else
#error READ THE README FILE!
#endif
#include <ncurses.h>
#include "opts.h"
#include "elfe.h"

#define OPTLINES LINES - LOGOS - 3
#define OWCOLS COLS - OPTCOLS 
#define OWLINES LINES - LOGOS - 3
#define OWNCOL (OWCOLS * OWLINES)*-1

/* some external vars */
extern WINDOW *optw,*ow;
extern int is32bit,fd;
extern void *filec;
extern  Elf32_Ehdr *Elfhdr32;
extern  Elf64_Ehdr *Elfhdr64;

extern long fsize;
#define C_WINS \
    wclear(optw);\
    wclear(ow);\
    wrefresh(optw);\
    wrefresh(ow);\
    
static int ti;
int cl;    
static void eascii(struct datae *,int,int*);

bool changes = 0;
void edata(char *data,int *size) 
{
    int i,cline,ccol,c,cg;	
    int mseg;			
    struct datae *datae,*d,*td;			

    if(!*size)
	return;
	
    ccol = cline = cg = 0;
    datae = (struct datae *)malloc(sizeof(struct datae)); 
    
    if(!datae) {
emem:    
        wclear(ow);	
        wprintw(ow,"Out of memory ouch!\n");
        for(d = datae->next;d;d = d->next)
	    free(d->prev);

	wrefresh(ow);
	return;
    }
    
    d = datae;
    for(i = 0;i < *size;i++,d = d->next) {
	d->col = ccol;
	d->line = cline;
	d->seg = cg;
	d->data = *(data+i);
	d->next = (struct datae *)malloc(sizeof(struct datae)); 
	if(!d->next)	    
	    goto emem;

	d->next->prev = d;

	if(ccol >= OWCOLS - 7) {
	    ccol = 0;
	    if(cline == OWLINES - 1) {
		cline = 0;
		cg++;
	    }else 
		cline++;
	}else {
		ccol += 3;
	}

    }
    
    cl = cline;
    d = datae;
    mseg = cg;
    cg = 0;
    
#define ML(x,de)\
    wmove(ow,de->line,de->col);\
    wattron(ow,COLOR_PAIR(x));\
    wprintw(ow,"%x",de->data);\
    wattroff(ow,COLOR_PAIR(x));\
    waddch(ow,' ');\
    if(0x10 > de->data)\
        waddch(ow,' ');\
    
#define LIST_ALL\
    wclear(ow);\
    td = datae;\
    for(i = 0;i < *size;td = td->next,i++){\
	if(td->seg != cg)\
	    continue;\
	wmove(ow,td->line,td->col);\
	wprintw(ow,"%x ",td->data);\
	if(0x10 > td->data)\
	    waddch(ow,' '); \
    }\
    if(cg != mseg) { \
	wmove(ow,OWLINES,0);\
	wattrset(ow,COLOR_PAIR(NOTE));\
	waddstr(ow,"More");\
	waddch(ow,ACS_DARROW);\
    }\
    ML(HIGHLIGHT,d);\
    wrefresh(ow);

#define DIE\
    if(changes) { \
	td = datae;\
	for(cl = 0;cl < *size;cl++,td = td->next)\
	    *(data+cl) = td->data;\
    }
    
    LIST_ALL;
    wrefresh(ow);
    while(1) {
	switch(c = wgetch(ow)) {
	    case KEY_RIGHT:
		if(!d->next) break;
		if(!d->next->next) break;
		
		d = d->next;
		
	    	if(d->seg != cg) {
		    cg = d->seg;
		    LIST_ALL;
		    break;
		}
		
		ML(NORMAL,d->prev);
		ML(HIGHLIGHT,d);
		wrefresh(ow);
				
		break;
	    case KEY_LEFT:
		if(d == datae) break;
		
		d = d->prev;

		if(d->seg != cg) {
		    cg = d->seg; 
		    LIST_ALL;
		    break;
		}
		
		ML(NORMAL,d->next);
		ML(HIGHLIGHT,d);
		wrefresh(ow);
		break;
	    case KEY_DOWN:
		if(d->seg == mseg)
		    if(cline == d->line)
			break;
	
		td = d;		
		c = d->col;
		ML(NORMAL,d);
		
		for(d = d->next;c != d->col&&d->next->next;d = d->next)
		    continue;
		    
		if(!d->next->next)
		    d = td;	
		
		if(d->seg != cg) {
		    cg = d->seg;
		    LIST_ALL;
		    break;
		}
		    		
		ML(HIGHLIGHT,d);
		break;
	    case KEY_UP:
		if(!cg && !d->line)
		    break;
		    
		c = d->col;    
		ML(NORMAL,d);
		for(d = d->prev;c != d->col&&d;d = d->prev) 
		    continue;
		
		if(d->seg != cg) {
		    cg = d->seg;
		    LIST_ALL;
		    break;
		}
		
		ML(HIGHLIGHT,d);
		break;
	    case 'r':
		LIST_ALL;
		break;
	    case 'q':
		DIE;
		return;
		break;
	    case 'a':case 'b' : case 'c': case 'd':case 'e': case 'f':
	    case '0':case '1':case '2':case '3':case '4':case '5':case '6':
	    case '7':case '8':case '9':
	    
		ungetch(c);			
		wmove(ow,d->line,d->col);
		waddstr(ow,"  ");
		wrefresh(ow);
		
		/* fine you can see what your typing */
		echo();
		wmove(ow,d->line,d->col);
		wscanw(ow,"%x",&c);
		d->data = (unsigned char)c;
		noecho();
		
		changes = 1;
		d = d->next;
    		LIST_ALL;
		break;
	    case KEY_NPAGE:
		if(mseg == cg)
		    break;
		    	    
		for(d = d;d->seg == cg;d = d->next)
		    continue;
		cg++;
		LIST_ALL;
		break;
	    case KEY_PPAGE:
		if(cg == 0) 
		    break;
		
		for(d = d;d->seg == cg;d = d->prev)
		    continue;

		cg--;
		LIST_ALL;
		break;
	    case 0x1:
		eascii(datae,mseg,size);
		LIST_ALL;
		break;
	}
    }		
#undef LIST_ALL
#undef ML
#undef DIE    
}

static void eascii(struct datae *data,int mseg,int *s) 
{
    struct datae *tmp,*cp;
    int i,seg = 0;
    int count = 0;
    int l,c;
    
    cp = data;

#define DISPLAYA\
    wclear(ow);\
    c = count;\
    for(tmp = data,i = 0;i < *s;i++,tmp = tmp->next) {\
	if(tmp->seg != seg) \
	    continue;\
\
	if(!tmp->col){\
	    count = 0;\
	}else\
	    count += 2;\
        HIGHLIGHTA(tmp,NORMAL);\
    }\
    count = c;\
    if(seg != mseg){\
	wmove(ow,OWLINES,0);\
	wattrset(ow,COLOR_PAIR(NOTE));\
	waddstr(ow,"More");\
	waddch(ow,ACS_DARROW);\
    }\
    HIGHLIGHTA(cp,HIGHLIGHT);\
    wrefresh(ow);

#define HIGHLIGHTA(x,perm)\
    wattron(ow,COLOR_PAIR(perm));\
    wmove(ow,x->line,x->col-count);\
\
    if(x->data == '\n')\
	waddch(ow,ACS_DARROW|A_BLINK);\
    else\
	wprintw(ow,"%c",x->data);\
\
    wattroff(ow,COLOR_PAIR(perm));
    
    DISPLAYA;
    
    l = 0;
    while(1) {
	switch(c = wgetch(ow)) { 
	    case KEY_RIGHT:
		if(!cp->next)
		    break;
		if(!cp->next->next) 
		    break;
		
		cp = cp->next;
 		if(cp->seg != seg) {
		    count = 0;
		    seg = cp->seg; 
		    DISPLAYA;
		    break;
		}
		
		HIGHLIGHTA(cp->prev,NORMAL);
		if(cp->line != l){ 
		    count = 0;
		    l = cp->line;
		}else 
		    count += 2;		

		HIGHLIGHTA(cp,HIGHLIGHT);
		wrefresh(ow);
		break;
	    case KEY_LEFT:
		if(!cp->prev)
		    break;
		    
		cp = cp->prev;
		if(cp->seg != seg)  { 
		    count = cp->col - ((OWCOLS-7) / 3);
		    seg = cp->seg;
		    DISPLAYA;
		    break;
		}

		HIGHLIGHTA(cp->next,NORMAL);
		if(cp->line != l){
		    count = cp->col - ((OWCOLS-7) / 3);
		    l = cp->line;
		}else
		    count -= 2;    

		HIGHLIGHTA(cp,HIGHLIGHT);
		wrefresh(ow);
		break;	
	    case KEY_NPAGE:
		if(mseg == seg)
		    break;
		
		count = 0;
		for(cp = cp;cp->seg == seg;cp = cp->next)
		    continue;
		
		seg++;
		DISPLAYA;
		break;
	    case KEY_PPAGE:
		if(seg == 0) 
		    break;
		
		for(cp = cp;cp->seg == seg;cp = cp->prev)
		    continue;
		    
		seg++;	
		count = cp->col - ((OWCOLS-7) / 3);
		DISPLAYA;
		break;
	    case KEY_DOWN:
		if(cp->seg == mseg)
		    if(cp->line == cl)
			break;
			
		HIGHLIGHTA(cp,NORMAL);
		tmp = cp;
		
		i = cp->col;	
		for(cp = cp->next;i != cp->col&&cp->next->next;cp = cp->next)
		    continue;
		    
		if(!cp->next->next)
		    cp = tmp;
		        
		if(cp->seg != seg){
		    seg = cp->seg;
		    DISPLAYA;
		    break;
		}
		HIGHLIGHTA(cp,HIGHLIGHT);
		wrefresh(ow);
		
		break;
	    case KEY_UP:
		if(!seg && !cp->line)
		    break;
		    
		HIGHLIGHTA(cp,NORMAL);
		
		i = cp->col;    	
		for(cp = cp->prev;i != cp->col;cp = cp->prev)
		    continue;
		
		if(cp->seg != seg) { 
		    cp->seg = seg;
		    DISPLAYA;
		    break;
		}
		
		HIGHLIGHTA(cp,HIGHLIGHT);
		wrefresh(ow);	
		break;
	    case 'q':
		return;
		break;
		
	    default : 
		if(!isascii(c)) 
		    break;
		
 		cp->data = c;
		changes = 1;
		if(!cp->next->next) {
		    HIGHLIGHTA(cp,HIGHLIGHT);
		    break;
		}
		
		ungetch(KEY_RIGHT);
		break;
	}
    }
#undef DISPLAYA
#undef HIGHLIGHTA
}    

void Sec_opt(void)
{
    Elf32_Shdr *sections;
    struct seclist *seclist,*csec,*slist;
    char *namestr;
    int i,j,cg;

    seclist = csec = slist = 0;
    if(!Elfhdr32->e_shnum){
	waddstr(ow,"No sections available");
	wrefresh(ow);
	return;
    }    


#define SNUM Elfhdr32->e_shnum    
    C_WINS;
    if(!is32bit) { 
	wmove(ow,0,0);
	waddstr(ow,"Option doesn't support elf64");
	return;
    }    

    sections = (Elf32_Shdr *)(filec + Elfhdr32->e_shoff);
    seclist = (struct seclist *)malloc(sizeof(struct seclist)*SNUM);
    slist = seclist;
    namestr = (char*)(filec + (sections+Elfhdr32->e_shstrndx)->sh_offset);    

    cg = cl = 0;
    for(i = 0;i < SNUM;i++,sections++,cl++) { 
	seclist->name = namestr+sections->sh_name;
	if(cl == OPTLINES) {
	    cg++;
	    cl = 0;
	}
	
	seclist->seg = cg; 
	seclist->l = cl;
	seclist->section = &(*sections);
	seclist++;
    }  

    seclist = seclist - SNUM;
    csec = seclist;
    if(!csec) {
	C_WINS;
	return;
    }
    
    cl = i = 1;
#define MO\
    wmove(optw,csec->l,2);\
    wprintw(optw,"%d Sec. ",i-1);\
    if(!*csec->name)\
        waddstr(optw,"(null)");\
    else \
        waddstr(optw,csec->name);\
    
#define MARKS\
    wclear(optw);\
    wdstr(optw,"back<");\
    for(cl = 0;seclist->seg != csec->seg;seclist++) cl++;\
\
    for(;seclist->seg == csec->seg&&seclist->section;seclist++) {\
	wmove(optw,seclist->l,2);\
	wprintw(optw,"%d Sec. ",cl);\
	if(!*seclist->name)\
	    waddstr(optw,"(null)");\
	else \
	    waddstr(optw,seclist->name);\
	cl++;\
    }\
\
    seclist = slist;\
    wattron(optw,COLOR_PAIR(HIGHLIGHT));\
    MO;\
    wattroff(optw,COLOR_PAIR(HIGHLIGHT));\
    if(csec->seg < cg) {\
	wmove(optw,OPTLINES,1);\
	wattron(optw,COLOR_PAIR(NOTE));\
	waddstr(optw,"More ");\
	waddch(optw,ACS_DARROW);\
    }\
    wattroff(optw,COLOR_PAIR(NOTE));\
    wrefresh(optw);
    
    j = csec->seg;
    MARKS;
    while(1) {
	switch(wgetch(optw)) { 
	    case KEY_UP:
		if(i == 1) break;
		MO;
		csec--;
		i--;
		if(j != csec->seg){ 
		    MARKS;
		    j = csec->seg;
		}else  {
		    wattron(optw,COLOR_PAIR(HIGHLIGHT));
		    MO;
		    wattroff(optw,COLOR_PAIR(HIGHLIGHT));
		}
		
		break;
	    case KEY_DOWN:
		if(i == SNUM) break;
		MO;
		csec++;
		i++;
		if(j != csec->seg) { 
		    j = csec->seg;
		    MARKS;
		}else {
		    wattron(optw,COLOR_PAIR(HIGHLIGHT));
		    MO;
		    wattroff(optw,COLOR_PAIR(HIGHLIGHT));

		}
		    
		break;
	    case KEY_NPAGE:
		if(j == cg)
		    break;
		
		for(;csec->seg == j;i++,csec++)
		    continue;
		
		j = csec->seg;
		MARKS;
		break;
	    case KEY_PPAGE:
		if(!j)
		    break;
		    
		for(;csec->seg == j;i--,csec--)
		    continue;
		    
		j = csec->seg;
		MARKS;
		break;        
	    case KEY_LEFT:
		return;
		break;
	    case KEY_RIGHT:
		edata(filec+csec->section->sh_offset,&csec->section->sh_size);
		wclear(ow);
		
		if(!changes) {
		    wrefresh(ow);
		    MARKS;
		    break;
		}
#define SAVEYN\
		changes = 0;\
		wmove(ow,0,0);\
		wprintw(ow,"Save changes yes/no [y/n] :");\
		wrefresh(ow);\
		ti = ow->_curx;\
		while(1){\
		    cl = wgetch(ow);\
		    wmove(ow,0,ti);\
		    if(cl == 'y'){ \
			save();\
			wprintw(ow,"Data saved!     ");/* added a few spacebar*/\
			break;			       /* just to erase parts */\
		    }else if(cl == 'n') {	       /* of the unknown option*/\
			wprintw(ow,"Data was not saved");\
			lseek(fd,0x0,SEEK_SET);\
			read(fd,filec,fsize);\
			break;\
		    }else{\
			wprintw(ow,"Unknown option");\
		    }\
\
		    wrefresh(ow);\
		}\
		wmove(ow,1,0);\
		wprintw(ow,"Press any key to continue");\
		wrefresh(ow);\
		wgetch(ow);\
\
		wclear(ow);\
		wrefresh(ow);
		
		SAVEYN;
    		MARKS;
		break;
    	    case 'i':
		wclear(ow);
		wmove(ow,1,1);
		
		waddstr(ow,"Type:");
		switch(csec->section->sh_type) { 
		    case SHT_NULL:
			waddstr(ow,"NULL");	
			break;
		    case SHT_PROGBITS:
			waddstr(ow,"PROGBITS");
			break;
		    case SHT_SYMTAB:
			waddstr(ow,"SYMTAB");
			break;
		    case SHT_STRTAB:
			waddstr(ow,"STRTAB");
			break;
		    case SHT_RELA:
			waddstr(ow,"RELA");
			break;
		    case SHT_HASH:
			waddstr(ow,"HASH");
			break;
		    case SHT_DYNAMIC:
			waddstr(ow,"DYNAMIC");
			break;
		    case SHT_NOTE:
			waddstr(ow,"NOTE");
			break;
		    case SHT_NOBITS:
			waddstr(ow,"NOBITS");
			break;
		    case SHT_REL:
			waddstr(ow,"REL");
			break;
		    case SHT_SHLIB:
			waddstr(ow,"SHLIB");
			break;
		    case SHT_DYNSYM:
			waddstr(ow,"DYNSYM");
			break;
		    case SHT_LOPROC:
			waddstr(ow,"LOPROC");
			break;
		    case SHT_HIPROC:
			waddstr(ow,"HIPROC");
			break;
		    case SHT_LOUSER:
			waddstr(ow,"LOUSER");
			break;
		    case SHT_HIUSER:
			waddstr(ow,"HIUSER");
			break;
		    default:
			waddstr(ow,"Unknown");
		}
		
		wmove(ow,2,1);
		waddstr(ow,"Flags:");
#define F csec->section->sh_flags		
		if(F&SHF_WRITE)
		    waddstr(ow,"WRITE,");
		if(F&SHF_ALLOC)
		    waddstr(ow,"ALLOC,");
		if(F&SHF_EXECINSTR)
		    waddstr(ow,"EXECINSTR,");
		if(F&SHF_MASKPROC)
		    waddstr(ow,"MASKPROC");
		
		wmove(ow,3,1);
		wprintw(ow,"Addr:0x%x",csec->section->sh_addr);
		wmove(ow,4,1);
		wprintw(ow,"Size:0x%x",csec->section->sh_size);
		wmove(ow,5,1);
		wprintw(ow,"Link:%d",csec->section->sh_link);
		wmove(ow,6,1);
		wprintw(ow,"Addralign:0x%x",csec->section->sh_addralign);
		
		wrefresh(ow);
		wgetch(ow);
		wclear(ow);
		wrefresh(ow);
		wmove(optw,csec->l,2);
		break;
	    default:
		break;
	};
    }

#undef MARKS
#undef MO    
#undef SNUM

}

/* I found it meaningless to edit the program header */
/*
void Prog_opt(void)
{
    Elf32_Phdr *proghdr;
    struct plist *plist,*sprog,*tmpp;
    int i;
    
    proghdr = (Elf32_Phdr *)(filec + Elfhdr32->e_phoff);
    plist = (struct plist *)malloc(sizeof(struct plist));

    sprog = plist;
    
    cg = cl = 0;
    for(i = 0,tmpp = plist;i < Elfhdr32->e_phnum;i++) { 
	if(cl == OPTLINES) { 
	    cl = 1;
	    cg++;
	}
	
	tmpp->seg = cg;	 
	tmpp->line = cl;
	tmpp->id = i+1;
	tmpp->phdr = proghdr+i*Elfhdr32->e_phentsize;	
	
	tmpp->next = (struct plist*)malloc(sizeof(struct plist));
	tmpp->next->prev = tmpp;
	tmpp = tmpp->next;
    }
    
    cg = 0;


#define PH(perm,w)\
    wmove(optw,w->line,2);\
    wattron(optw,COLOR_PAIR(perm));\
    wprintw(optw,"Program header %d#",w->id);\
    wattroff(optw,COLOR_PAIR(perm));\
    wrefresh(optw);\

#define LIST_ALL\
    wclear(optw);\
    for(tmpp = plist;tmpp->seg == cg && tmpp->next;tmpp = tmpp->next) {\
	wmove(optw,tmpp->line,2);\
	wprintw(optw,"Program header %d#",tmpp->id);\
    }\
\
    PH(HIGHLIGHT,sprog);
        
    LIST_ALL;
    
    while(1) { 
	switch(wgetch(optw)) { 
	    case KEY_LEFT:
		return;
	    case KEY_UP:
		if(sprog == plist) 
		    break;
		
		PH(NORMAL,sprog);
		sprog = sprog->prev;
		if(cg != sprog->seg) {
		    LIST_ALL;
		    break;
		}else 
		    PH(HIGHLIGHT,sprog);
		    
		break;
	    case KEY_DOWN:
		if(!sprog->next->next) 
		    break;
		    
		PH(NORMAL,sprog);
		sprog = sprog->next;
		if(cg != sprog->seg) { 
		    LIST_ALL;
		    break;
		}else 
		    PH(HIGHLIGHT,sprog);
		
		break;	    	
	    default:
		 break;
	}
    }	
#undef PH
#undef LIST_ALL
}
*/

void Sym_opt(void)
{
    Elf32_Shdr *symtab,*str,*s;
    struct syml *symlist,*sym,*stmp;
    int i,Symnum,cg,mseg;
    
    s = (filec+Elfhdr32->e_shoff);
    symtab =  str = NULL;    

    for(symtab = 0,i = 0;i < Elfhdr32->e_shnum;i++,s++){
	if(s->sh_type == SHT_SYMTAB){
		symtab = &(*s);
		break;
	}
    }
    
    s = s-i;
#define DEATH(error)\
    waddstr(ow,error);\
    wrefresh(ow);\
    return;
    
    if(!symtab) {
	DEATH("Missing symtab section");
    }

    str = s+symtab->sh_link;
    Symnum = symtab->sh_size/sizeof(Elf32_Sym);
    symlist = (struct syml*)malloc(sizeof(struct syml));
    
    cg = cl = 0;
    for(i = 0,sym = symlist;i < Symnum;i++,sym = sym->next,cl++) { 
	sym->y = cl;
	sym->seg = cg;
	
	if(cl == OPTLINES-1){
	    cg++;
            cl = -1;
	}
	
	sym->symbol = (filec+symtab->sh_offset+sizeof(Elf32_Sym)*i);
	sym->name = (filec+str->sh_offset+sym->symbol->st_name);
	sym->next = (struct syml *)malloc(sizeof(struct syml));
	sym->next->prev = sym;
    }
    
    mseg = cg;
    cg = 0;
    sym = symlist;
#define SYMSHOW\
\
    wclear(optw);\
    wdstr(optw,"back<");\
    stmp = symlist;\
    for(i = 0;i < Symnum;i++,stmp = stmp->next) {\
	if(stmp->seg != cg)\
	    continue;\
	SHOWSYM(stmp,NORMAL);\
    }\
\
    SHOWSYM(sym,HIGHLIGHT);\
    if(sym->seg != mseg) { \
	wmove(optw,OPTLINES,1);\
	wattron(optw,COLOR_PAIR(NOTE));\
	waddstr(optw,"More ");\
	waddch(optw,ACS_DARROW);\
	wattroff(optw,COLOR_PAIR(NOTE));\
    }\
\
    wrefresh(optw);

#define SHOWSYM(symb,color)\
\
    wmove(optw,symb->y,2);\
    wattrset(optw,COLOR_PAIR(color));\
\
    if(!*symb->name)\
	waddstr(optw,"(null)");\
    else\
	waddstr(optw,symb->name);\
\
    wattroff(optw,COLOR_PAIR(color));\
    wrefresh(optw);

    SYMSHOW;
    
    while(1) { 
	switch(wgetch(optw)) {
	    case KEY_DOWN:
		if(!sym->next->next)
		    break;
		
		sym = sym->next;
		if(sym->seg != cg){
		    cg++;
		    SYMSHOW;
		    break;
		}
		
		SHOWSYM(sym->prev,NORMAL);
		SHOWSYM(sym,HIGHLIGHT);
		break;
	    case KEY_UP:
		if(!sym->prev)
		    break;
		
		sym = sym->prev;
		if(sym->seg != cg){
		    cg--;
		    SYMSHOW;
		    break;
		}
		
		SHOWSYM(sym->next,NORMAL);
		SHOWSYM(sym,HIGHLIGHT);
		break;
	    case KEY_RIGHT:
		if(!sym->symbol->st_size){
		    waddstr(ow,"Unknown size of symbol");
		    wrefresh(ow);
		    wgetch(ow);
		    wmove(optw,0,0);
		    break;
		}
		
		s = (filec+Elfhdr32->e_shoff);
		s += sym->symbol->st_shndx;
		edata(filec+s->sh_offset+sym->symbol->st_value-Elfhdr32->e_entry
		,&sym->symbol->st_size);
		
		wclear(ow);
		if(!changes){ 
		    SYMSHOW;
		    wrefresh(ow);
		    break;
		}
		
		SAVEYN
		break;
	    case KEY_LEFT:
		return;
		break;
	    case KEY_NPAGE:
		if(cg == mseg)
		    break;
		    
		for(sym = sym->next;sym->seg == cg;sym = sym->next)
		    continue;
		    
		cg = sym->seg;    
		SYMSHOW;
		break;
	    case KEY_PPAGE:
		if(!cg)
		    break;
		    
		for(sym = sym->prev;sym->seg == cg;sym = sym->prev)
		    continue;
		
		cg = sym->seg;
		SYMSHOW;
		break;    	
	    case 'i':
		wclear(ow);
		wmove(ow,1,1);
		wprintw(ow,"Value(Address):0x%x",sym->symbol->st_value);
		wmove(ow,2,1);
		wprintw(ow,"Size:0x%x",sym->symbol->st_size);
		
		wmove(ow,3,1);
		wprintw(ow,"Info Bind:");

		switch(ELF32_ST_BIND(sym->symbol->st_info)) { 
		    case STB_LOCAL:
			waddstr(ow,"STB_LOCAL");
			break;
		    case STB_GLOBAL:
			waddstr(ow,"STB_GLOBAL");
			break;
		    case STB_WEAK:
			waddstr(ow,"STB_WEAK");
			break;
		    case STB_LOPROC:
			waddstr(ow,"STB_LOPROC");
			break;
		    case STB_HIPROC:
			waddstr(ow,"STB_HIPROC");
			break;
		    default:
			waddstr(ow,"Unknown");
			break;
		};
		
		wmove(ow,4,1);
		waddstr(ow,"Type:");		
		
		switch(ELF32_ST_TYPE(sym->symbol->st_info)) { 
		    case STT_NOTYPE:
			waddstr(ow,"STT_NOTYPE,");
			break;
		    case STT_OBJECT:
			waddstr(ow,"STT_OBJECT,");
			break;
		    case STT_FUNC:
			waddstr(ow,"STT_FUNC,");
		    case STT_SECTION:
			waddstr(ow,"STT_SECTION,");
			break;
		    case STT_FILE:
			waddstr(ow,"STT_FILE,");
			break;
		    case STT_LOPROC:
			waddstr(ow,"STT_LOPROC,");
			break;
		    case STT_HIPROC:
			waddstr(ow,"STT_HIPROC,");
			break;
		    default:
			waddstr(ow,"Unknown");
			break;
		}
		
		wmove(ow,5,1);
		wprintw(ow,"Section:%d",sym->symbol->st_shndx);
    		
		wrefresh(ow);
		wgetch(ow);
		
		wclear(ow);
		wrefresh(ow);
		SYMSHOW;
		break;
	    default:
		break;
	}
    }
}

#undef SAVEYN
