#include <ncurses.h>
#include "elfe.h"

extern WINDOW *mainw,*optw,*ow,*logo;
int init_win()
{
    if((mainw = initscr()) == NULL) {
        perror("init_scr()");
        exit(139);
    }
    cbreak();
    noecho();
    start_color();
    nonl();
#define SWIN(w,yn,xn,y,x)\
        w = newwin(yn,xn,y,x);\
        box(w,ACS_VLINE,ACS_HLINE);\
        wrefresh(w);\
        w = newwin(yn-2,xn-2,y+1,x+1);\
        if(!w) { \
            perror("newwin");\
        }
    SWIN(optw,LINES - LOGOS,OPTCOLS,LOGOS,0)
    SWIN(ow,LINES - LOGOS,COLS - OPTCOLS,LOGOS,OPTCOLS)
    SWIN(logo,LOGOS,COLS,0,0)

    keypad(optw,TRUE);
    keypad(ow,TRUE);
    init_colors();
#undef SWIN
    
    return 1;
}

void wdstr(WINDOW *win,char *ptr)
{
    wattron(win,COLOR_PAIR(NOTE));    
    for(wmove(win,1,0);*ptr;ptr++){
	waddch(win,*ptr);
	win->_cury++;
	win->_curx = 0;
    }
    wattroff(win,COLOR_PAIR(NOTE));
}
    
void init_colors(void)
{
    init_pair(HIGHLIGHT,COLOR_BLACK,COLOR_RED);
    init_pair(NOTE,COLOR_BLACK,COLOR_BLUE);
    init_pair(NORMAL,COLOR_WHITE,COLOR_BLACK);
}

